% =========================================================================
% Copyright (c) 2008-2014 Audio Communication Group, TU Berlin
% 
% This file is part of WhisPER, a package of interacting MATLAB scripts for 
% designing and controlling experiments in the field of auditory perceptive 
% measurement and evaluation.
% 
% WhisPER is free software: you can redistribute it and/or modify it under 
% the terms of the GNU General Public License as published by the Free 
% Software Foundation, either version 3 of the License, or (at your option) 
% any later version. 
% 
% WhisPER is distributed in the hope that it will be useful, but WITHOUT ANY 
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
% FOR A PARTICULAR PURPOSE.
% See the GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
% with this program. If not, see <http://www.gnu.org/licenses/>. 
% 
% http://www.ak.tu-berlin.de/whisper/ 
% =========================================================================
% 
% This file:
%
% Author :   Martina Vrhovnik and Fabian Brinkmann,
%            Audio Communication Group, TU Berlin
% Email  :   fabian.brinkmann at tu-berlin dot de
% Date   :   Oct. 2013
% Updated: 
%             
% =========================================================================


function varargout = saqi_edit_main(varargin)
% SAQI_EDIT_MAIN M-file for saqi_edit_main.fig
%      SAQI_EDIT_MAIN, by itself, creates a new SAQI_EDIT_MAIN or raises the existing
%      singleton*.
%
%      H = SAQI_EDIT_MAIN returns the handle to a new SAQI_EDIT_MAIN or the handle to
%      the existing singleton*.
%
%      SAQI_EDIT_MAIN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SAQI_EDIT_MAIN.M with the given input arguments.
%
%      SAQI_EDIT_MAIN('Property','Value',...) creates a new SAQI_EDIT_MAIN or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before saqi_edit_main_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to saqi_edit_main_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help saqi_edit_main

% Last Modified by GUIDE v2.5 06-Oct-2013 21:45:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @saqi_edit_main_OpeningFcn, ...
                   'gui_OutputFcn',  @saqi_edit_main_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before saqi_edit_main is made visible.
function saqi_edit_main_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to saqi_edit_main (see VARARGIN)

% Choose default command line output for saqi_edit_main
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes saqi_edit_main wait for user response (see UIRESUME)
% uiwait(handles.fig_saqi_edit_main);

movegui(hObject,'center');

global TSP PP current_slider_size tmp_random_stimuli
load ([PP.path filesep 'TSP.mat']);

% Figure display name
set(hObject,'Name',['Main Settings (' TSP.sections{PP.edit_section_line,2} ')']);

% ---- Set Values from TSP ----
set(handles.ed_initial_subject_instruction,'String', TSP.sections{PP.edit_section_line,4}{1,2});    % instructions
set(handles.pop_language,'Value',TSP.sections{PP.edit_section_line,4}{1,3}{1});                     % language
set(handles.cb_item_definition,'Value',TSP.sections{PP.edit_section_line,4}{1,3}{2});               % show item definition

% Ask for categorization 1 (Zeitver?nderlichkeit),2 (Stetigkeit) or 3 (Interaktivit?t)
set(handles.cb_categorization1,'Value',TSP.sections{PP.edit_section_line,4}{1,3}{3});
set(handles.cb_categorization2,'Value',TSP.sections{PP.edit_section_line,4}{1,3}{4});
set(handles.cb_categorization3,'Value',TSP.sections{PP.edit_section_line,4}{1,3}{5});

%Ask for assessment entities
set(handles.cb_assessment_entities,'Value',TSP.sections{PP.edit_section_line,4}{1,3}{6});

% Scale size (default = 5)
switch TSP.sections{PP.edit_section_line,4}{1,3}{9}
    case 3
        set(handles.rad_set_scale_size_3, 'Value', 1)    
    case 5
        set(handles.rad_set_scale_size_5, 'Value', 1)
    case 7
        set(handles.rad_set_scale_size_7, 'Value', 1)
end
current_slider_size = TSP.sections{PP.edit_section_line,4}{1,3}{9};

% Randomize scale poles (default = 0)
set(handles.cb_rand_scale_poles,'Value',TSP.sections{PP.edit_section_line,4}{1,3}{10});

%Compare to inner reference
set(handles.cb_inner_reference,'Value',TSP.sections{PP.edit_section_line,4}{1,3}{11});
switch get(handles.cb_inner_reference, 'Value')
    case 0
        temp_string = 'on'; 
    case 1
        temp_string = 'off';   
end
set (handles.txt_stimulus_B, 'enable', temp_string);
set (handles.txt_assign_b, 'enable', temp_string);
set (handles.cb_randomstimuli, 'enable', temp_string);

% Randomize stimuli
set(handles.cb_randomstimuli,'Value',TSP.sections{PP.edit_section_line,4}{1,3}{12});
tmp_random_stimuli = get(handles.cb_randomstimuli, 'value');

% Randomize items
set(handles.cb_randomize_items,'Value',TSP.sections{PP.edit_section_line,4}{1,3}{13});

%Stimuli setting
if isempty(TSP.sections{PP.edit_section_line,4}{1,5}) == 0
set(handles.txt_assign_a,'String',TSP.stimuli{TSP.sections{PP.edit_section_line,4}{1,5}(1,1),2});
set(handles.txt_assign_b,'String',TSP.stimuli{TSP.sections{PP.edit_section_line,4}{1,5}(1,2),2});
end



% --- Outputs from this function are returned to the command line.
function varargout = saqi_edit_main_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes when user attempts to close fig_saqi_edit_main.
function fig_saqi_edit_main_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to fig_saqi_edit_main (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global PP

if PP.dontopenparent~=1
    edit_procedures
end
PP.dontopenparent=0;

% Hint: delete(hObject) closes the figure
delete(hObject);


% --- Executes on button press in pb_save.
function pb_save_Callback(hObject, eventdata, handles)
% hObject    handle to pb_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global PP TSP current_slider_size 
%  save settings to TSP
TSP.sections{PP.edit_section_line,4}{1,2} = get(handles.ed_initial_subject_instruction,'String');
TSP.sections{PP.edit_section_line,4}{1,3}{1} = get(handles.pop_language,'Value');
TSP.sections{PP.edit_section_line,4}{1,3}{2} = get(handles.cb_item_definition,'Value');
TSP.sections{PP.edit_section_line,4}{1,3}{3} = get(handles.cb_categorization1,'Value');
TSP.sections{PP.edit_section_line,4}{1,3}{4} = get(handles.cb_categorization2,'Value');
TSP.sections{PP.edit_section_line,4}{1,3}{5} = get(handles.cb_categorization3,'Value');
TSP.sections{PP.edit_section_line,4}{1,3}{6} = get(handles.cb_assessment_entities,'Value');
TSP.sections{PP.edit_section_line,4}{1,3}{9} = current_slider_size;
TSP.sections{PP.edit_section_line,4}{1,3}{10} = get(handles.cb_rand_scale_poles,'Value');
TSP.sections{PP.edit_section_line,4}{1,3}{11} = get(handles.cb_inner_reference,'Value');
TSP.sections{PP.edit_section_line,4}{1,3}{12} = get(handles.cb_randomstimuli,'Value');
TSP.sections{PP.edit_section_line,4}{1,3}{13} = get(handles.cb_randomize_items,'Value');

% update language files is done in 'pop_language' callback because the
% selected language needs to be availably directly for editing the items,
% categories and entities

% save TSP and close SAQI settings
save ([PP.path filesep 'TSP.mat'],'TSP');
close
edit_procedures

% --- Executes on button press in pb_cancel.
function pb_cancel_Callback(hObject, eventdata, handles)
% hObject    handle to pb_cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close
edit_procedures


function ed_initial_subject_instruction_Callback(hObject, eventdata, handles)
% hObject    handle to ed_initial_subject_instruction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ed_initial_subject_instruction as text
%        str2double(get(hObject,'String')) returns contents of ed_initial_subject_instruction as a double


% --- Executes during object creation, after setting all properties.
function ed_initial_subject_instruction_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ed_initial_subject_instruction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

 % --- Executes on key press with focus on ed_initial_subject_instruction and no controls selected.
function ed_initial_subject_instruction_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to ed_initial_subject_instruction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Cancel-Button wird aktiviert, da ?nderungen vorgenommen wurden, die der User m?glicherweise R?ckg?ngig machen will
 set(handles.pb_cancel,'Enable', 'on');


% --- Executes on button press in pb_edit_assign.
function pb_edit_assign_Callback(hObject, eventdata, handles)
% hObject    handle to pb_edit_assign (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%global PP
%PP.edit_track_line=get(handles.lb_tracks,'Value');
%PP.dontopenparent=1; %verhindern, dass beim schlie?en die ?bergeordnete GUI ge?ffnet wird
%pb_save_Callback(hObject, eventdata, handles) %Speichern und schlie?en
saqi_stimulus_selection



% --- Executes on selection change in lb_tracks.
function lb_tracks_Callback(hObject, eventdata, handles)
% hObject    handle to lb_tracks (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns lb_tracks contents as cell array
%        contents{get(hObject,'Value')} returns selected item from lb_tracks


% --- Executes during object creation, after setting all properties.
function lb_tracks_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lb_tracks (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txt_assign_a_Callback(hObject, eventdata, handles)
% hObject    handle to txt_assign_a (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_assign_a as text
%        str2double(get(hObject,'String')) returns contents of txt_assign_a as a double


% --- Executes during object creation, after setting all properties.
function txt_assign_a_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_assign_a (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txt_assign_b_Callback(hObject, eventdata, handles)
% hObject    handle to txt_assign_b (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_assign_b as text
%        str2double(get(hObject,'String')) returns contents of txt_assign_b as a double


% --- Executes during object creation, after setting all properties.
function txt_assign_b_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_assign_b (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_refresh_stimuli_list.
function pb_refresh_stimuli_list_Callback(hObject, eventdata, handles)
% hObject    handle to pb_refresh_stimuli_list (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global TSP PP

if ~isempty(TSP.sections{PP.edit_section_line,4}{1,5})
    set(handles.txt_assign_a,'String',TSP.stimuli{TSP.sections{PP.edit_section_line,4}{1,5}(1,1),2});
    set(handles.txt_assign_b,'String',TSP.stimuli{TSP.sections{PP.edit_section_line,4}{1,5}(1,2),2});
else
    PP.whisper_message = 'Edit assignment first';
    whisper_message
end


% --- Executes on button press in cb_randomstimuli.
function cb_randomstimuli_Callback(hObject, eventdata, handles)
% hObject    handle to cb_randomstimuli (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_randomstimuli

% save value separately because it is set to 0 if user selects 'compare to
% inner reference' and it is set to it's previous vale if 'compare to inner
% reference' is unchecked before the changes were saved
global tmp_random_stimuli
tmp_random_stimuli = get(hObject,'Value');


% --- Executes on selection change in pop_language.
function pop_language_Callback(hObject, eventdata, handles)
% hObject    handle to pop_language (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns pop_language contents as cell array
%        contents{get(hObject,'Value')} returns selected item from pop_language

% update language files is done in 'pop_language' callback because the
% selected language needs to be availably directly for editing the items,
% categories and entities
global TSP PP

switch get(handles.pop_language,'Value')
    case 1 % german
        % items and item categories
        saqi_items_german;
        TSP.sections{PP.edit_section_line,4}{1,6} = SAQI_Items;
        saqi_categories_german;
        TSP.sections{PP.edit_section_line,4}{1,12} = SAQI_categories;
        % scale label
        saqi_scale_label_german;
        TSP.sections{PP.edit_section_line,4}{1,7} = SAQI_scale_label;
        % assessment entities
        saqi_entities_german;
        TSP.sections{PP.edit_section_line,4}{1,11} = SAQI_Entities;
        % phrases
        saqi_phrases_german;
        TSP.sections{PP.edit_section_line,4}{1,9} = SAQI_phrases;
        % definitions
        saqi_definition_german;
        TSP.sections{PP.edit_section_line,4}{1,14} = SAQI_definition;
    case 2 % english
        % items and item categories
        saqi_items_english;
        TSP.sections{PP.edit_section_line,4}{1,6} = SAQI_Items;
        saqi_categories_english;
        TSP.sections{PP.edit_section_line,4}{1,12} = SAQI_categories;
        % scale label
        saqi_scale_label_english;
        TSP.sections{PP.edit_section_line,4}{1,7} = SAQI_scale_label;
        % assessment entities
        saqi_entities_english;
        TSP.sections{PP.edit_section_line,4}{1,11} = SAQI_Entities;
        % phrases
        saqi_phrases_english;
        TSP.sections{PP.edit_section_line,4}{1,9} = SAQI_phrases;
        % definitions
        saqi_definition_english;
        TSP.sections{PP.edit_section_line,4}{1,14} = SAQI_definition;
end


% --- Executes during object creation, after setting all properties.
function pop_language_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pop_language (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_edit_items.
function pb_edit_items_Callback(hObject, eventdata, handles)
% hObject    handle to pb_edit_items (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
saqi_edit_items


% --- Executes on button press in cb_categorization1.
function cb_categorization1_Callback(hObject, eventdata, handles)
% hObject    handle to cb_categorization1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_categorization1
global tmp_cb_categorization2_value
if get(hObject,'Value')
    set(handles.cb_categorization2, 'Value', tmp_cb_categorization2_value, 'Enable', 'on')
else
    tmp_cb_categorization2_value = get(handles.cb_categorization2,'Value');
    set(handles.cb_categorization2, 'Value', 0, 'Enable', 'off');
end

% --- Executes on button press in cb_categorization2.
function cb_categorization2_Callback(hObject, eventdata, handles)
% hObject    handle to cb_categorization2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_categorization2

% --- Executes on button press in cb_categorization3.
function cb_categorization3_Callback(hObject, eventdata, handles)
% hObject    handle to cb_categorization3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_categorization3


% --- Executes on button press in cb_assessment_entities.
function cb_assessment_entities_Callback(hObject, eventdata, handles)
% hObject    handle to cb_assessment_entities (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_assessment_entities


% --- Executes on button press in pb_edit_assessment_entities.
function pb_edit_assessment_entities_Callback(hObject, eventdata, handles)
% hObject    handle to pb_edit_assessment_entities (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
saqi_edit_entities

% --- Executes on button press in cb_item_definition.
function cb_item_definition_Callback(hObject, eventdata, handles)
% hObject    handle to cb_item_definition (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_item_definition


% --- Executes when selected object is changed in pan_set_scale_size.
function pan_set_scale_size_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in pan_set_scale_size 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
global current_slider_size

tmp = get(eventdata.NewValue,'Tag'); % Get Tag of selected object.
current_slider_size = str2double(tmp(end));

            

% --- Executes on button press in cb_inner_reference.
function cb_inner_reference_Callback(hObject, eventdata, handles)
% hObject    handle to cb_inner_reference (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_inner_reference
global tmp_random_stimuli

switch get(handles.cb_inner_reference, 'Value')
    case 0
        temp_string = 'on';
        set(handles.cb_randomstimuli, 'value', tmp_random_stimuli)
    case 1
        temp_string = 'off'; 
        set(handles.cb_randomstimuli, 'value', 0)
end
set (handles.txt_stimulus_B, 'enable', temp_string);
set (handles.txt_assign_b, 'enable', temp_string);
set (handles.cb_randomstimuli, 'enable', temp_string);
set (handles.txt_random_stimuli_2, 'enable', temp_string);


% --- Executes on button press in cb_rand_scale_poles.
function cb_rand_scale_poles_Callback(hObject, eventdata, handles)
% hObject    handle to cb_rand_scale_poles (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_rand_scale_poles

% --- Executes during object creation, after setting all properties.
function pan_scale_label_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pan_scale_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function pan_set_scale_type_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pan_set_scale_type (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in pb_edit_categories.
function pb_edit_categories_Callback(hObject, eventdata, handles)
% hObject    handle to pb_edit_categories (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function cb_rand_scale_poles_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cb_rand_scale_poles (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in cb_randomize_items.
function cb_randomize_items_Callback(hObject, eventdata, handles)
% hObject    handle to cb_randomize_items (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_randomize_items



% --- Executes on button press in cb_randomize_categories.
function cb_randomize_categories_Callback(hObject, eventdata, handles)
% hObject    handle to cb_randomize_categories (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_randomize_categories

