% =========================================================================
% Copyright (c) 2008-2014 Audio Communication Group, TU Berlin
% 
% This file is part of WhisPER, a package of interacting MATLAB scripts for 
% designing and controlling experiments in the field of auditory perceptive 
% measurement and evaluation.
% 
% WhisPER is free software: you can redistribute it and/or modify it under 
% the terms of the GNU General Public License as published by the Free 
% Software Foundation, either version 3 of the License, or (at your option) 
% any later version. 
% 
% WhisPER is distributed in the hope that it will be useful, but WITHOUT ANY 
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
% FOR A PARTICULAR PURPOSE.
% See the GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
% with this program. If not, see <http://www.gnu.org/licenses/>. 
% 
% http://www.ak.tu-berlin.de/whisper/ 
% =========================================================================
% 
% This file:
%
% Author :   Martina Vrhovnik and Fabian Brinkmann,
%            Audio Communication Group, TU Berlin
% Email  :   fabian.brinkmann at tu-berlin dot de
% Date   :   Oct. 2013
% Updated: 
%             
% =========================================================================

% This script holds all scale labels/poles:
% Item id (see saqi_items), negative pole, positive pole
SAQI_scale_label = ...   
{...
1 'none' 'very large'; ...
2 'darker' 'brighter'; ...
3 'attenuated' 'emphasized'; ...
4 'attenuated' 'emphasized';...
5 'attenuated' 'emphasized';...
6 'less sharp' 'sharper';...
7 'less rough' 'more rough';...
8 'less pronounced' 'more pronounced';...
9 'less pronounced' 'more pronounced';...
10 'less tonal' 'more tonal';...
11 'lower' 'higher';...
12 'less pronounced' 'more pronounced';...
13 'shifted anticlockwise' 'shifted clockwise';...
14 'shifted up' 'shifted down';...
15 'not confused' 'confused';...
16 'closer' 'more distant';...
17 'less deep' 'deeper';...
18 'less wide' 'wider';...
19 'less high' 'higher';...
20 'more internalized' 'more externalized';...
21 'more difficult' 'easier';...
22 'more coherent' 'more disjointed';...
23 'less' 'more';...
24 'shorter' 'longer';...
25 'less pronounced' 'more pronounced';...
26 'less intense' 'more intense';...
27 'less intense' 'more intense';...
28 'more coherent' 'more disjointed';...
29 'less pronounced' 'more pronounced';...
30 'reduced' 'increased';...
31 'unchanged' 'changed';...
32 'lower' 'higher';...
33 'quieter' 'louder';...
34 'smaller' 'larger';...
35 'less pronounced' 'more pronounced';...
36 'less intense' 'more intense';...
37 'less intense' 'more intense';...
37 'less intense' 'more intense';...
39 'less intense' 'more intense';...
40 'less intense' 'more intense';...
41 'less intense' 'more intense';...
42 'less intense' 'more intense';...
43 'less pronounced' 'more pronounced';...
44 'lower' 'higher';...
45 'lower' 'higher';...
46 'lower' 'higher';...
47 'lower' 'higher';...
48 'less pronounced' 'more pronounced';...
};
