% =========================================================================
% Copyright (c) 2008-2014 Audio Communication Group, TU Berlin
% 
% This file is part of WhisPER, a package of interacting MATLAB scripts for 
% designing and controlling experiments in the field of auditory perceptive 
% measurement and evaluation.
% 
% WhisPER is free software: you can redistribute it and/or modify it under 
% the terms of the GNU General Public License as published by the Free 
% Software Foundation, either version 3 of the License, or (at your option) 
% any later version. 
% 
% WhisPER is distributed in the hope that it will be useful, but WITHOUT ANY 
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
% FOR A PARTICULAR PURPOSE.
% See the GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
% with this program. If not, see <http://www.gnu.org/licenses/>. 
% 
% http://www.ak.tu-berlin.de/whisper/ 
% =========================================================================
%
% This file:
%
% Author :   Martina Vrhovnik and Fabian Brinkmann,
%            Audio Communication Group, TU Berlin
% Email  :   fabian.brinkmann at tu-berlin dot de
% Date   :   Oct. 2013
% Updated:
%
% =========================================================================

function varargout = saqi_vp_2(varargin)
% SAQI_VP_2 MATLAB code for saqi_vp_2.fig
%      SAQI_VP_2, by itself, creates a new SAQI_VP_2 or raises the existing
%      singleton*.
%
%      H = SAQI_VP_2 returns the handle to a new SAQI_VP_2 or the handle to
%      the existing singleton*.
%
%      SAQI_VP_2('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SAQI_VP_2.M with the given input arguments.
%
%      SAQI_VP_2('Property','Value',...) creates a new SAQI_VP_2 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before saqi_vp_2_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to saqi_vp_2_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help saqi_vp_2

% Last Modified by GUIDE v2.5 20-Feb-2014 12:12:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @saqi_vp_2_OpeningFcn, ...
    'gui_OutputFcn',  @saqi_vp_2_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before saqi_vp_2 is made visible.
function saqi_vp_2_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to saqi_vp_2 (see VARARGIN)

% Choose default command line output for saqi_vp_2
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes saqi_vp_2 wait for user response (see UIRESUME)
% uiwait(handles.fig_saqi_vp_2);
movegui(hObject,'center');

global PP TSP

% increase counter that saves the current item
% (1 = overall difference, 2,3,... items)
PP.current_id = PP.current_id +1;
PP.current_item = TSP.sections{PP.run_section_line,4}{1,4}{PP.current_id};
PP.item = TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,2};

% Figure display name
set(hObject,'Name',['Quality ' num2str(PP.current_id) '/' num2str(PP.number_of_items) ': ' PP.item   ' (' TSP.sections{PP.run_section_line,2} ')']);

% to check if stimuli were played back
PP.play_A = 0;
PP.play_B = 0;

% make play_B button invisible if we are comparing against a inner
% reference and repostion play_b and stop button
if TSP.sections{PP.run_section_line,4}{1,3}{11}
    set(handles.pb_play_b, 'Visible', 'off');
    set (handles.pb_play_a, 'Position', [42.200000000000045 28.923076923076934 12 2.9230769230769234]);
    set (handles.pb_stop, 'Position', [55.200000000000024 28.923076923076934 12 2.9230769230769234]);
    set(handles.txt_other, 'Position', [20.200000000000003 22.3 69.60000000000001 1.7692307692307696]);
end

% makes input window & information for the degree items invisible
set(handles.txt_angle, 'Visible', 'off');
set(handles.txt_180, 'Visible', 'off');

% initially enables slider, radio-buttons & ok-button, if stimuli were listened to
% before and are not randomized or if we are comparing to inner reference
if PP.current_id > 1 && (TSP.sections{PP.run_section_line,4}{1,3}{12} == 0 || TSP.sections{PP.run_section_line,4}{1,3}{11} == 1)
    set(handles.sli_scale, 'enable', 'on');
    set(handles.sli_unipolar, 'enable', 'on');
    set(handles.rad_dich_top, 'enable', 'on');
    set(handles.rad_dich_bottom, 'enable', 'on');
    set(handles.pb_ok, 'enable', 'on');
end

% set right question text
if PP.current_item == 1  % first question
    if TSP.sections{PP.run_section_line,4}{1,3}{1,11} % phrase for inner reference (Stimulus A only))
        set(handles.txt_question, 'String', TSP.sections{PP.run_section_line,4}{1,9}{1,2}{2,1});
    else % rating with A & B
        set(handles.txt_question, 'String', TSP.sections{PP.run_section_line,4}{1,9}{1,2}{1,1});
    end
    set(handles.txt_other, 'Visible', 'off');
    set(handles.txt_item, 'Visible', 'off');
elseif PP.current_id == numel(TSP.sections{PP.run_section_line,4}{1,4}) % last question
    if TSP.sections{PP.run_section_line,4}{1,3}{1,11} % phrase for inner reference (Stimulus A only))
        set(handles.txt_question, 'String', TSP.sections{PP.run_section_line,4}{1,9}{14,2}{2,1});
    else
        set(handles.txt_question, 'String', TSP.sections{PP.run_section_line,4}{1,9}{14,2}{1,1});
        set(handles.txt_other, 'Position', [20.200000000000003 22.3 69.60000000000001 1.7692307692307696]);
    end
    set(handles.txt_item, 'Visible', 'off');
else % rating selected item questions
    set(handles.txt_question, 'String', TSP.sections{PP.run_section_line,4}{1,9}{2,2});
    set(handles.txt_item, 'String', TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,2});
    set(handles.txt_other, 'Visible', 'off');
    set(handles.txt_item, 'Position', [20.200000000000003 22.692307692307697 69.60000000000001 1.7692307692307696]);
    set(handles.txt_question, 'Position', [3 22.153846153846168 104.2 5.0]);
end

% set scale label
if PP.rand_scale_label(PP.current_id) == 0 % no randomization of scale label
    if ~TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,3} &&... % not dichotom "A:"
            ~TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,4}       % not unipolar
        set(handles.txt_scale_label_top, 'String', ['A: ' TSP.sections{PP.run_section_line,4}{1,7}{PP.current_item,3}]);
        set(handles.txt_scale_label_bottom, 'String', ['A: ' TSP.sections{PP.run_section_line,4}{1,7}{PP.current_item,2}]);
    else
        set(handles.txt_scale_label_top, 'String', TSP.sections{PP.run_section_line,4}{1,7}{PP.current_item,3});
        set(handles.txt_scale_label_bottom, 'String', TSP.sections{PP.run_section_line,4}{1,7}{PP.current_item,2});
    end
else % randomization
    if ~TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,3} &&... % not dichotom "A:"
            ~TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,4}       % not unipolar
        set(handles.txt_scale_label_top, 'String', ['A: ' TSP.sections{PP.run_section_line,4}{1,7}{PP.current_item,2}]);
        set(handles.txt_scale_label_bottom, 'String', ['A: ' TSP.sections{PP.run_section_line,4}{1,7}{PP.current_item,3}]);
    else
        set(handles.txt_scale_label_top, 'String', TSP.sections{PP.run_section_line,4}{1,7}{PP.current_item,2});
        set(handles.txt_scale_label_bottom, 'String', TSP.sections{PP.run_section_line,4}{1,7}{PP.current_item,3});
    end
end

% set scale annotation and position of objects
if TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,3} == 1   % dichotom
    % set default value
    if PP.rand_scale_label(PP.current_id)
        set(handles.rad_dich_top, 'Value', 1);
    else
        set(handles.rad_dich_bottom, 'Value', 1);
    end
    set(handles.sli_unipolar, 'Visible', 'off'); % disable unipolar slider
    set(handles.sli_scale, 'Visible', 'off'); % disable bipolar slider
    set(handles.txt_scale_label_top, 'Position' , [35.4 17 38.2 1.46]);
    set(handles.txt_scale_label_bottom, 'Position', [35.4 8 38.2 1.46]);
    set(handles.rad_dich_top, 'Position' , [53 15 4.4 2.23]);
    set(handles.rad_dich_bottom, 'Position' , [53 9.3 4.4 2.23]);
    set(handles.txt_scale_1, 'Visible', 'off');
    set(handles.txt_scale_2, 'Visible', 'off');
    set(handles.txt_scale_3, 'Visible', 'off');
    set(handles.txt_scale_4, 'Visible', 'off');
    set(handles.txt_scale_5, 'Visible', 'off');
    set(handles.txt_scale_6, 'Visible', 'off');
    set(handles.txt_scale_7, 'Visible', 'off');
    
elseif TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,6} == 1   % degree scale (elevation, azimuth)
    set(handles.txt_scale_1, 'Visible', 'off');
    set(handles.txt_scale_2, 'Visible', 'off');
    set(handles.txt_scale_3, 'Visible', 'off');
    set(handles.txt_scale_4, 'Visible', 'off');
    set(handles.txt_scale_5, 'Visible', 'off');
    set(handles.txt_scale_6, 'Visible', 'off');
    set(handles.txt_scale_7, 'Visible', 'off');
    set(handles.sli_scale, 'Visible', 'off');
    set(handles.sli_unipolar, 'Visible', 'off');
    set(handles.rad_dich_top,'Position' ,[52.4 14.615 4.4 2.231]);
    set(handles.rad_dich_bottom, 'Position' , [52.4 8.92 4.4 2.32]);
    set(handles.txt_angle,'Visible', 'on', 'Position', [44.6 11.53 20.2 2.69]);
    set(handles.txt_180, 'Visible', 'on', 'Position', [66 11 20.2 2.69]);
    set(handles.txt_180, 'String', TSP.sections{PP.run_section_line,4}{1,9}{16,2});
    set(handles.txt_scale_label_top, 'Position', [16.8 17 75.6 1.69]);
    set(handles.txt_scale_label_bottom, 'Position', [24 5 61.6 3.92]);
    
elseif TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,4} == 1 % unipolar scale
    set(handles.sli_unipolar, 'Position', [50.4 4.384615384615385 8.6 8.692]); %set unipolar slider
    set(handles.sli_scale, 'Visible', 'off'); % disable bipolar slider
    % set default value
    if PP.rand_scale_label(PP.current_id)
        set(handles.sli_unipolar, 'Value', 1)
    else
        set(handles.sli_unipolar, 'Value', 0)
    end
    
    switch TSP.sections{PP.run_section_line,4}{1,3}{9} % scale size (unipolar)
        case 3 %(0&1) % set scale label to scale size position 1(top) 3(bottom)
            % scale_labels 0 & 1 invsible
            set(handles.txt_scale_label_top, 'Position', [59.4 10.94 38.2 1.46], 'HorizontalAlignment', 'left', ...
                'String', ['--- ' get(handles.txt_scale_label_top, 'String')]);
            set(handles.txt_scale_label_bottom, 'Position', [59.4 5.38  38.2 1.46], 'HorizontalAlignment', 'left', ...
                'String', ['--- ' get(handles.txt_scale_label_bottom, 'String')]);
            set(handles.txt_scale_1, 'Visible', 'off');
            set(handles.txt_scale_2, 'Visible', 'off');
            set(handles.txt_scale_3, 'Visible', 'off');
            set(handles.txt_scale_4, 'Visible', 'off');
            set(handles.txt_scale_5, 'Visible', 'off');
            set(handles.txt_scale_6, 'Visible', 'off');
            set(handles.txt_scale_7, 'Visible', 'off');
            set(handles.rad_dich_top,'Visible', 'off' );
            set(handles.rad_dich_bottom,'Visible', 'off');
            
        case 5 %(0,1&2)
            
            set(handles.txt_scale_4, 'Visible', 'off');
            set(handles.txt_scale_5, 'Visible', 'off');
            set(handles.txt_scale_6, 'Visible', 'off');
            set(handles.txt_scale_7, 'Visible', 'off');
            set(handles.txt_scale_label_top, 'Position', [33 13.1 42.2 1.692307692307693]); %set upper scale label
            set(handles.txt_scale_label_bottom, 'Position', [33.2 1.8461538461538463 42.0 2.076923076923077]); %set lower scale label
            set(handles.rad_dich_top,'Visible', 'off' );
            set(handles.rad_dich_bottom,'Visible', 'off');
            
            if PP.rand_scale_label(PP.current_id) == 0 % no randomization scale label
                set(handles.txt_scale_1,'String', '--- 2', 'Position', [59.4 10.94 38.2 1.46]);
                set(handles.txt_scale_2,'String', '--- 1', 'Position', [59.4 8.15 38.2 1.46]);
                set(handles.txt_scale_3,'String', '--- 0', 'Position', [59.4 5.38  38.2 1.46]);
            else
                set(handles.txt_scale_1,'String', '--- 0', 'Position', [59.4 10.94 38.2 1.46]);
                set(handles.txt_scale_2,'String', '--- 1', 'Position', [59.4 8.15 38.2 1.46]);
                set(handles.txt_scale_3,'String', '--- 2', 'Position', [59.4 5.38  38.2 1.46]);
            end
            
        case 7 %(0,1,2&3)
            set(handles.txt_scale_5, 'Visible', 'off');
            set(handles.txt_scale_6, 'Visible', 'off');
            set(handles.txt_scale_7, 'Visible', 'off');
            set(handles.rad_dich_top,'Visible', 'off' );
            set(handles.rad_dich_bottom,'Visible', 'off');
            set(handles.txt_scale_label_top, 'Position', [33 13.1 42.2 1.692307692307693]); %set upper scale label
            set(handles.txt_scale_label_bottom, 'Position', [33.2 1.8461538461538463 42.0 2.076923076923077]); %set lower scale label
            
            if PP.rand_scale_label(PP.current_id) == 0 % no randomization of scale label
                set(handles.txt_scale_1,'String', '--- 3', 'Position', [59.4 10.94 38.2 1.46]);
                set(handles.txt_scale_2,'String', '--- 2', 'Position', [59.4 9.1   38.2 1.46]);
                set(handles.txt_scale_3,'String', '--- 1', 'Position', [59.4 7.2   38.2 1.46]);
                set(handles.txt_scale_4,'String', '--- 0', 'Position', [59.4 5.38  38.2 1.46]);
            else
                set(handles.txt_scale_1,'String', '--- 0', 'Position', [59.4 10.94   38.2 1.46]);
                set(handles.txt_scale_2,'String', '--- 1', 'Position', [59.4 9.1 38.2 1.46]);
                set(handles.txt_scale_3,'String', '--- 2', 'Position', [59.4 7.2 38.2 1.46]);
                set(handles.txt_scale_4,'String', '--- 3', 'Position', [59.4 5.38  38.2 1.46]);
            end
    end
    
    
elseif TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,4} == 0 % bipolar
    set(handles.sli_unipolar, 'Visible', 'off'); % disable unipolar slider
    switch TSP.sections{PP.run_section_line,4}{1,3}{9} % scale size (bipolar)
        case 3
            set(handles.txt_scale_label_top, 'Position', [59.4 18 38.2 1.46], 'HorizontalAlignment', 'left', ...
                'String', ['--- ' get(handles.txt_scale_label_top, 'String')]);
            set(handles.txt_scale_label_bottom, 'Position', [59.4 6.6 38.2 1.46], 'HorizontalAlignment', 'left', ...
                'String', ['--- ' get(handles.txt_scale_label_bottom, 'String')]);
            set(handles.txt_scale_2, 'String', '--- 0', 'Position', [59.4 12.3 38.2 1.46]);
            set(handles.txt_scale_1,'Visible', 'off');
            set(handles.txt_scale_3,'Visible', 'off');
            set(handles.txt_scale_4,'Visible', 'off');
            set(handles.txt_scale_5,'Visible', 'off');
            set(handles.txt_scale_6,'Visible', 'off');
            set(handles.txt_scale_7,'Visible', 'off');
            set(handles.rad_dich_top,'Visible', 'off' );
            set(handles.rad_dich_bottom,'Visible', 'off');
        case 5
            set(handles.txt_scale_1,'String', '--- 2', 'Position', [59.4 18    38.2 1.46]);
            set(handles.txt_scale_2,'String', '--- 1', 'Position', [59.4 15.15 38.2 1.46]);
            set(handles.txt_scale_3,'String', '--- 0', 'Position', [59.4 12.3  38.2 1.46]);
            set(handles.txt_scale_4,'String', '--- 1', 'Position', [59.4 9.45  38.2 1.46]);
            set(handles.txt_scale_5,'String', '--- 2', 'Position', [59.4 6.6   38.2 1.46]);
            set(handles.txt_scale_6,'Visible', 'off');
            set(handles.txt_scale_7,'Visible', 'off');
            set(handles.rad_dich_top,'Visible', 'off' );
            set(handles.rad_dich_bottom,'Visible', 'off');
        case 7
            set(handles.txt_scale_1,'String', '--- 3', 'Position', [59.4 18   38.2 1.46]);
            set(handles.txt_scale_2,'String', '--- 2', 'Position', [59.4 16.1 38.2 1.46]);
            set(handles.txt_scale_3,'String', '--- 1', 'Position', [59.4 14.2 38.2 1.46]);
            set(handles.txt_scale_4,'String', '--- 0', 'Position', [59.4 12.3 38.2 1.46]);
            set(handles.txt_scale_5,'String', '--- 1', 'Position', [59.4 10.4  38.2 1.46]);
            set(handles.txt_scale_6,'String', '--- 2', 'Position', [59.4 8.5  38.2 1.46]);
            set(handles.txt_scale_7,'String', '--- 3', 'Position', [59.4 6.6  38.2 1.46]);
            set(handles.rad_dich_top,'Visible', 'off' );
            set(handles.rad_dich_bottom,'Visible', 'off');
    end
    
end


% --- Outputs from this function are returned to the command line.
function varargout = saqi_vp_2_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pb_play_a.
function pb_play_a_Callback(hObject, eventdata, handles)
% hObject    handle to pb_play_a (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global TSP PP

% set was_played flag
PP.play_A = 1;
% decide which stimuli to play based on randomization
if PP.rand_stimuli(PP.current_id)
    present_stimulus(TSP.sections{PP.run_section_line,4}{1,5}(2));
else
    present_stimulus(TSP.sections{PP.run_section_line,4}{1,5}(1));
end
% enable objects based on was_played flag
if (PP.play_A && PP.play_B) || (PP.play_A && TSP.sections{PP.run_section_line,4}{1,3}{11})
    set(handles.sli_unipolar, 'enable', 'on');
    set(handles.rad_dich_top, 'enable', 'on');
    set(handles.rad_dich_bottom, 'enable', 'on');
    set(handles.sli_scale, 'enable', 'on');
    set(handles.pb_ok, 'enable', 'on');
end



% --- Executes on button press in pb_play_b.
function pb_play_b_Callback(hObject, eventdata, handles)
% hObject    handle to pb_play_b (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global TSP PP

% set was_played flag
PP.play_B = 1;
% decide which stimuli to play based on randomization
if PP.rand_stimuli(PP.current_id)
    present_stimulus(TSP.sections{PP.run_section_line,4}{1,5}(1));
else
    present_stimulus(TSP.sections{PP.run_section_line,4}{1,5}(2));
end
% enable objects based on was_played flag
if (PP.play_A && PP.play_B)
    set(handles.sli_unipolar, 'enable', 'on');
    set(handles.rad_dich_top, 'enable', 'on');
    set(handles.rad_dich_bottom, 'enable', 'on');
    set(handles.sli_scale, 'enable', 'on');
    set(handles.pb_ok, 'enable', 'on');
end

% --- Executes on button press in pb_ok.
function pb_ok_Callback(hObject, eventdata, handles)
% hObject    handle to pb_ok (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global PP TSD TSP player

% Stop the player
if ~isempty(player)
    stop(player);
end

for n = 1:numel(PP.u)
    fopen(PP.u{n});
    oscsend(PP.u{n},PP.osc_stop_path,PP.osc_stop_type,PP.osc_stop_data);
    fclose(PP.u{n});
end

% get rating
if TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,3} == 1 % dichotom
    if PP.rand_scale_label(PP.current_id)
        tmp_rating = get(handles.rad_dich_bottom, 'Value');
    else
        tmp_rating = get(handles.rad_dich_top, 'Value');
    end
elseif TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,4} == 1 % unipolar
    tmp_rating = get(handles.sli_unipolar, 'Value');
    if PP.rand_scale_label(PP.current_id)
        tmp_rating = 1-tmp_rating;
    end
elseif TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,6} == 1 % degree
    tmp_rating = get(handles.txt_angle, 'String');
    if isempty(tmp_rating)
        tmp_rating = 0;
    else
        tmp_rating = str2double(tmp_rating)/180; % normed rating
    end
    
    if get(handles.rad_dich_bottom, 'Value')
        tmp_rating = -tmp_rating;
    elseif PP.rand_scale_label(PP.current_id) && get(handles.rad_dich_top, 'Value')
        tmp_rating = -tmp_rating;
    end
else
    tmp_rating = get(handles.sli_scale, 'Value'); % bipolar
    if PP.rand_scale_label(PP.current_id)
        tmp_rating = -tmp_rating;
    end
    if PP.rand_stimuli(PP.current_id) % randomized stimuli
        tmp_rating = -tmp_rating;
    end
end

% save user name for 'other' item if it was rated
if PP.current_id == numel(TSP.sections{PP.run_section_line,4}{1,4}) && tmp_rating
    if ~isempty(get(handles.txt_other, 'String')) % optional input at last question
        PP.subject_data{PP.current_item+1,2} = get(handles.txt_other, 'String');
        do_continue = 1;
    else
        PP.whisper_message = 'Please give a description in the text-field';
        whisper_message;
        do_continue = 0;
    end
elseif PP.current_id == numel(TSP.sections{PP.run_section_line,4}{1,4}) && tmp_rating == 0
    if ~isempty(get(handles.txt_other, 'String')) % optional input at last question
        PP.whisper_message = 'Please rate or delete the text in the description field';
        whisper_message;
        do_continue = 0;
    else
        do_continue = 1;
    end
elseif TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,6} == 1 % degree
    degree_rating = get(handles.txt_angle, 'String');
    top = get(handles.rad_dich_top, 'Value');
    bottom = get(handles.rad_dich_bottom, 'Value');
    if isempty(degree_rating) 
        degree_rating = 0;
    else
        degree_rating = str2double(degree_rating);
    end
    if degree_rating > 180 || degree_rating < 0
        PP.whisper_message = 'Your input must be between 0 & 180!';
        whisper_message;
        do_continue = 0;
    else
        do_continue = 1;
    end 
else
    do_continue = 1;
end


if do_continue
    % save flag indicating that a difference was perceived
    PP.subject_data{PP.current_item+1,15} = tmp_rating;
    if tmp_rating ~= 0
        PP.subject_data{PP.current_item+1,6} = 1;
    else
        PP.subject_data{PP.current_item+1,6} = 0;
    end
    
    % save to TSD
    TSD{PP.run_number+1,3+(PP.run_section_line-1)*3+1} = PP.subject_data;
    save ([PP.path filesep 'TSD.mat'],'TSD');
    
    % close current window
    PP.allowed_to_close = 1;
    close
    PP.allowed_to_close = 0;
    
    % check what to do next
    if tmp_rating
        if TSP.sections{PP.run_section_line,4}{1,3}{3} % go to categorization time variance
            saqi_vp_5;
        elseif TSP.sections{PP.run_section_line,4}{1,3}{5} % go to categorization interactivity
            saqi_vp_6;
        elseif TSP.sections{PP.run_section_line,4}{1,3}{6} % go to assessment entities
            saqi_vp_7;
        elseif PP.current_id == numel(TSP.sections{PP.run_section_line,4}{1,4}) % last item
            PP.run_section_line = PP.run_section_line+1;
            vp_main;
        elseif TSP.sections{PP.run_section_line,4}{1,3}{2} % go to next item definition
            saqi_vp_3;
        else  % go to next item rating
            saqi_vp_2;
        end
    else  % if tmp_rating == 0
        if PP.current_id == 1   % first item
            PP.run_section_line = PP.run_section_line+1;
            vp_main;
        elseif PP.current_id == numel(TSP.sections{PP.run_section_line,4}{1,4}) % last item
            PP.run_section_line = PP.run_section_line+1;
            vp_main;
        elseif TSP.sections{PP.run_section_line,4}{1,3}{2} % go to next item definition
            saqi_vp_3;
        else  % go to next item rating
            saqi_vp_2;
        end
    end
end

% --- Executes on slider movement.
function sli_scale_Callback(hObject, eventdata, handles)
% hObject    handle to sli_scale (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

% --- Executes during object creation, after setting all properties.
function sli_scale_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sli_scale (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function sli_unipolar_Callback(hObject, eventdata, handles)
% hObject    handle to sli_unipolar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sli_unipolar_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sli_unipolar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in pb_stop.
function pb_stop_Callback(hObject, eventdata, handles)
% hObject    handle to pb_stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global PP TSP player

% Stop the player
if ~isempty(player)
    stop(player);
end
% for n = 1:numel(PP.osc_address)
%     osc_send( PP.osc_address{n}, PP.osc_stop{n} );
% end
for n = 1:numel(PP.u)
    fopen(PP.u{n});
    oscsend(PP.u{n},PP.osc_stop_path,PP.osc_stop_type,PP.osc_stop_data);
    fclose(PP.u{n});
end

% --- Executes on button press in rad_dich_top.
function rad_dich_top_Callback(hObject, eventdata, handles)
% hObject    handle to rad_dich_top (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of rad_dich_top
if get(hObject,'Value')
    set(handles.rad_dich_bottom ,'Value', 0)
else
    set(handles.rad_dich_bottom ,'Value', 1)
end

% --- Executes on button press in rad_dich_bottom.
function rad_dich_bottom_Callback(hObject, eventdata, handles)
% hObject    handle to rad_dich_bottom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of rad_dich_bottom
if get(hObject,'Value')
    set(handles.rad_dich_top ,'Value', 0)
else
    set(handles.rad_dich_top ,'Value', 1)
end


% --- Executes when user attempts to close fig_saqi_vp_2.
function fig_saqi_vp_2_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to fig_saqi_vp_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
global PP
if PP.allowed_to_close==1
    delete(hObject);
end



function txt_other_Callback(hObject, eventdata, handles)
% hObject    handle to txt_other (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_other as text
%        str2double(get(hObject,'String')) returns contents of txt_other as a double


% --- Executes during object creation, after setting all properties.
function txt_other_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_other (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_reset.
function pb_reset_Callback(hObject, eventdata, handles)
% hObject    handle to pb_reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global PP TSP

% resets sliders on 0
if get(handles.sli_scale,'Value') ~= 0  % resets bipolar slider
    set(handles.sli_scale ,'Value', 0);
elseif get(handles.sli_unipolar, 'Value') ~=0 % resets unipolar slider
    set(handles.sli_unipolar, 'Value', 0);
    if PP.rand_scale_label(PP.current_id)
        set(handles.sli_unipolar, 'Value', 1);
    end
elseif TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,3}% resets pushbuttons of the dichotom item to Value 0
    set(handles.rad_dich_top, 'Value', 0);
    set(handles.rad_dich_bottom, 'Value', 0);
elseif TSP.sections{PP.run_section_line,4}{1,6}{PP.current_item,6} % resets pushbuttons of the degree items
    set(handles.rad_dich_top, 'Value', 0);
    set(handles.rad_dich_bottom, 'Value', 0);
    set(handles.txt_angle, 'String', ''); % delets user's input in the "degree" field
end

screen = get(handles.txt_other, 'String');   % delets user's input in the "other" field
if ~isempty(screen)
    screen = '';
    set(handles.txt_other, 'String', screen);
end


function txt_angle_Callback(hObject, eventdata, handles)
% hObject    handle to txt_angle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txt_angle as text
%        str2double(get(hObject,'String')) returns contents of txt_angle as a double


% --- Executes during object creation, after setting all properties.
function txt_angle_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txt_angle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
global PP TSP

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
